ChangeLog
=========

If you encounter any problems with updating, please try the following:
1. `npm run clean` or `npm run cleanall`
2. Retry update (Don't forget `npm i`)

Migration
------------------------------
#### 1
```
npm i -g ts-node
```

#### 2
```
npm run migrate
```

11.22.0 (2019/06/18)
--------------------
### ✨Improvements
* 管理画面でデータベースの各テーブルのレコード数やサイズを確認できるように
* サーバー情報にPostgreSQLのバージョンを追加

### 🐛Fixes
* リモートファイルのダウンロードに失敗することがある問題を修正
* アンケートの期間を日時指定で選択すると日時がUTCになってしまう問題を修正
* MFMのパースを修正

11.21.0 (2019/06/16)
--------------------
### ✨Improvements
* Unicode 12.0 の絵文字に対応
* 閉鎖しているホストにはAP deliverしないように
* image以外はproxyしないように

### 🐛Fixes
* サムネイル生成でエラーになるとファイルのアップロードに失敗する問題を修正
* オートコンプリートにアニメーション停止が効かない問題を修正

11.20.4 (2019/06/13)
--------------------
### 🐛Fixes
* 検索結果がループする問題を修正
* 設定でPostgreSQLのクエリー結果のキャッシュを無効できるように
* 「投稿内の動きのあるテキストを無効にする」だけ反応しない問題を修正
* 特定の操作のデータベースのパフォーマンス調整

11.20.3 (2019/06/10)
--------------------
### 🐛Fixes
* 絵文字サジェストが動作しなくなっていた問題を修正

11.20.2 (2019/06/10)
--------------------
### 🐛Fixes
* Redisにパスワードを設定している場合接続できない問題を修正
* i18n
* など

11.20.1 (2019/06/07)
--------------------
### 🐛Fixes
* リモートファイルのキャッシュをすべて削除するときの動作を修正
* ストリームのハッシュタグチャンネルが死んでいる問題を修正
* Pagesから他の同一インスタンス内のPagesのページへのリンクができない問題を修正
* /api/notes/create 公開範囲private を渡すとタイムアウトする問題を修正
* パスワードの確認が完了しなくてもユーザー登録できる問題を修正
* 依存関係の更新
* i18n

11.20.0 (2019/05/27)
--------------------
### ✨Improvements
* 管理画面からリモートファイルのキャッシュをすべて削除できるように
* 投稿フォームに投稿のURLをペーストしようとすると引用RNにできるように
* モバイル版の投稿フォームにファイルをドロップできるように
* モバイル版でも投稿の下書き自動保存ができるように
* リモートファイルのキャッシュが期限切れになったときにサムネイルが無くならないように
* ジョブキュー管理画面を強化

### 🐛Fixes
* 投稿内のローカルなURLプレビューをクリックしたとき not found になることがある問題を修正
* デスクトップでユーザーページに遷移するときページが再度読み込みされることがある問題を修正
* フォロー申請自動承認オプションが常にオフで表示される問題を修正
* ポートを設定せずに起動したときに適切なエラーメッセージが表示されない問題を修正
* i18n

11.19.1 (2019/05/26)
--------------------
### 🐛Fixes
* タグページを遷移してもタイムラインが変わらない問題を修正
* インスタンス名を空にしてもMisskeyロゴが表示されない問題を修正
* 投稿内のローカルなURLをクリックしたとき not found になることがある問題を修正
* npm run init がプロセス終了しない問題を修正

11.19.0 (2019/05/25)
--------------------
### ✨Improvements
* グループのオーナーを変えられるように
* PagesでURLプレビューを表示するように
* サーバーログを削除できるように
* リンク先が同じインスタンスの投稿内のURLをクリックしたときは新しいタブで開かないように
* PostgreSQLの接続オプションを設定ファイルで設定できるように
* いくつかのAPIでのパフォーマンスを向上
* ユーザビリティの向上
* デザインの調整

### 🐛Fixes
* デッキでユーザーページを遷移したときに前のユーザーのタイムラインが残り続ける問題を修正
* デッキでフォロー申請が見れない問題を修正
* グループ情報が更新できない問題を修正
* Firefoxでトークの下が隠れてしまう問題を修正
* トーク履歴がないと履歴が読み込み中のままになる問題を修正
* 通知で長い名前のユーザーがいると横スクロールが発生する問題を修正
* iOSでの選択ダイアログの動作を修正

11.18.1 (2019/05/21)
--------------------
### 🐛Fixes
* 11.18.0からフォロー/フォロワーのもっと読み込む機能が作動していない問題を修正
* iOSで投稿フォームに自動フォーカスしない問題を修正
* ダークモードでグループ名がみにくい問題を修正
* ハッシュタグタイムラインを読み込んだ時にプログレスバーが残り続ける問題を修正
* ユーザビリティの修正

11.18.0 (2019/05/21)
--------------------
### ✨Improvements
* デザインの調整

### 🐛Fixes
* 投稿の削除が連合しない問題を修正

11.17.1 (2019/05/20)
--------------------
### 🐛Fixes
* トークの通知インジケーターが点灯し続ける問題を修正
* ユーザーグループの読み込みでエラーになることがある問題を修正

11.17.0 (2019/05/19)
--------------------
### 注意
このアップデートを適用した後、プロセスを起動(もしくは再起動)する前に[マイグレーション](#migration)の手順を実行してください

### ✨Improvements
* ユーザーグループを招待制に

### 🐛Fixes
* フォロー申請が表示されない問題を修正
* トークの通知インジケーターが点灯し続ける問題を修正
* 自分を自分のグループから削除できる問題を修正
* 新しいタブでグループトークを開くことができない問題を修正

11.16.1 (2019/05/19)
--------------------
### 🐛Fixes
* Dockerで起動できない問題を修正

11.16.0 (2019/05/19)
--------------------
### 注意
このアップデートを適用した後、プロセスを起動(もしくは再起動)する前に[マイグレーション](#migration)の手順を実行してください

### ✨Improvements
* ユーザーグループ機能を追加
* ページに「いいね」できるように
* UIの改善

### 🐛Fixes
* トークを読み込むときに最大数指定できなかった問題を修正

11.15.0 (2019/05/16)
--------------------
### ✨Improvements
* 管理画面でreCAPTCHAのプレビューを表示するように

### 🐛Fixes
* オブジェクトストレージのリージョンの設定が反映されない問題を修正

11.14.0 (2019/05/16)
--------------------
### 注意
このバージョンからオブジェクトストレージの設定は設定ファイルではなく管理画面から行うようになりました。
オブジェクトストレージを使用している場合、アップデートした後管理画面にアクセスしオブジェクトストレージの設定を再度行ってください。

### ✨Improvements
* 特定のユーザーのファイルをすべて削除できるように
* インスタンスの設定画面を整理

### 🐛Fixes
* GIF画像のサムネイルが生成されないのを修正
* 管理画面の「ログ」で複数の除外条件を設定できない問題を修正

11.13.0 (2019/05/14)
--------------------
### 注意
このアップデートを適用した後、プロセスを起動(もしくは再起動)する前に[マイグレーション](#migration)の手順を実行してください

### ✨Improvements
* 利用規約URL、リポジトリURL、フィードバックURLを設定できるように
* 特定のインスタンスのファイルをすべて削除できるように
* _blankで外部リンクされる可能性がある箇所にnoopenerを追加
* ユーザーや外部インスタンスが生成するリンクにnofollowを追加
* リモートのユーザーページやノートページにnoindexを追加
* 自分のユーザーメニューにはミュートなどを表示しないように
* デザインの調整

### 🐛Fixes
* インスタンスブロックを設定できない問題を修正
* ピン留め投稿の表示順がおかしい問題を修正
* 設定の「アップデートを確認」でメッセージが正しく表示されない問題を修正
* Firefoxで自分のメニューが開けない問題を修正
* Welcomeページのタグクラウドが動かない問題を修正

11.12.0 (2019/05/10)
--------------------
### 注意
このアップデートを適用した後、プロセスを起動(もしくは再起動)する前に[マイグレーション](#migration)の手順を実行してください

### ✨ Improvements
* インスタンス運営者がおすすめアカウントを設定できるように
* MisskeyPagesでNAME環境変数がNULLにならないように
* MisskeyPagesにNULL環境変数を追加
* MisskeyPagesで変数を並べ替えられるように
* MisskeyPagesのテキストのリスト内で変数埋め込みできるように
* 自分の指定した投稿のRenoteを全て解除するAPIを追加

### 🐛Fixes
* Noteをpull取得した時にhost名がvalidateされていない問題を修正
* みつけるで人気のタグが表示されない問題を修正

### その他
* アカウントのisVerifiedフラグを廃止

11.11.2 (2019/05/07)
--------------------
### 🐛Fixes
* IPv4 onlyホストからDualstackホストにAP deliverできない問題を修正
* ストリーミングに接続するまでラグがある問題を修正
* 2段階認証のコードが0から始まる時正しく入力できない問題を修正
* ユーザーの更新日時が新しい順で更新日時がnullのユーザーが先頭に来る問題を修正
* 値選択時の問題を修正
* リバーシでマップの変更が反映されない問題を修正
* リバーシで対局終了直後に盤面を巻き戻してもすぐ最終ターンまでリセットされる問題を修正

11.11.1 (2019/05/05)
--------------------
### 🐛Fixes
* MisskeyPagesのリストから選択関数が使えない問題を修正

11.11.0 (2019/05/05)
--------------------
### ✨ Improvements
* MisskeyPagesにリストから選択関数を追加
* MisskeyPagesに確率を指定できるテキストランダム選択関数を追加
* 外部サービス連携ログインリンクにアイコン追加

### 🐛Fixes
* MisskeyPagesでifを入れ子にできなくなっていた問題を修正
* MisskeyPagesで数値入力を作成するとテキスト入力になる問題を修正
* 外部サービス連携に関する問題を修正

11.10.1 (2019/05/04)
--------------------
### 🐛Fixes
* MisskeyPagesでページブロックを削除できなくなっていた問題を修正

### その他
* Node.js v12対応

11.10.0 (2019/05/03)
--------------------
### 注意
このアップデートを適用した後、プロセスを起動(もしくは再起動)する前に[マイグレーション](#migration)の手順を実行してください

### ✨ Improvements
* MisskeyPagesに割った余りを求める関数を追加
* Mastodon v2.8.0 のフォローリストをインポートできるように
* エクスポートリクエストに失敗したらエラーを表示するように
* エクスポートファイルでは同一ハッシュチェックをしないように

### 🐛Fixes
* 2段階認証を設定するとログインできなくなる問題を修正
* ファイルをアップロードできないことがある問題を修正
* リモートファイルをキャッシュしない設定だとサムネイル時にオリジナル画像が表示されない問題を修正
* 外部サービス連携の不具合を修正

11.9.0 (2019/05/02)
-------------------
### ✨ Improvements
* MisskeyPagesで編集時にページブロックをドラッグで並べ替えられるように
* MisskeyPagesにカウンターボタンブロックを追加

11.8.1 (2019/05/02)
-------------------
### 🐛Fixes
* リモートファイルをキャッシュしないオプション有効時にファイルが作成できない問題を修正

11.8.0-2 (2019/05/01)
-------------------
* 11.8.0 のリリース内容が 11.7.0 と同一だったのを修正

11.8.0 (2019/05/01)
-------------------
### ✨ Improvements
* MisskeyPagesで関数を作成できるように
* MisskeyPagesでソースを表示できるように
* MisskeyPagesにシードを与えるランダム関数を追加
* MisskeyPagesに複数行テキストをテキストのリストに変換する関数を追加

### 🐛Fixes
* APIドキュメントが見れなくなっていたのを修正
* mention (あなた宛て) streaming にミュートが効かない問題を修正
* デザインの調整

11.7.0 (2019/04/30)
-------------------
### ✨ Improvements
* MisskeyPagesに ifブロック を追加
* MisskeyPagesに テキストエリア を追加
* MisskeyPagesに 複数行テキスト入力 を追加
* MisskeyPagesに 投稿フォーム を追加
* MisskeyPagesに 変換系関数 を追加
* MisskeyPagesに 環境変数 URL を追加
* MisskeyPagesでボタンやスイッチなどのテキストに変数使えるように

### 🐛Fixes
* OGPのサイト名を修正
* デザインの調整

11.6.0 (2019/04/29)
-------------------
### ✨ Improvements
* AiScriptにいくつかの文字列操作関数を追加
* ページ編集画面にページへのリンクを表示するように

### 🐛Fixes
* MisskeyPagesで数値入力が文字列として扱われる問題を修正
* デザインの調整

11.5.1 (2019/04/29)
-------------------
### 🐛Fixes
* MisskeyPagesで環境変数を別の変数内で使えない問題を修正
* MisskeyPagesで値が0の変数が表示されない問題を修正

11.5.0 (2019/04/29)
-------------------
### 注意
このアップデートを適用した後、プロセスを起動(もしくは再起動)する前に[マイグレーション](migration)の手順を実行してください

### New features
#### MisskeyPages
ページ(記事)を作成できるように。

* 後から何度でも編集できる
* アイキャッチを設定できる
* フォントを設定できる
* 画像を好きな位置に挿入できる
* URLを決められる
* タイトルを設定できる
* 見出しを設定できる
* ページの要約を設定できる(URLプレビュー時などに便利)
* 変数や式(aka AiScript)を使用して動的なページも作れる
* 目次自動生成(coming soon)

ページを気に入ったら「いいね」しよう (coming soon)

### ✨ Improvements
* APIコンソールでパラメータテンプレートを表示するように

### 🐛Fixes
* おすすめユーザーに自分自身が含まれる問題を修正
* ユーザーサジェストで表示名が変わらない問題を修正

11.4.0 (2019/04/25)
-------------------
### ✨ Improvements
* 検索でローカルの投稿のみに絞れるように
* 検索で特定のインスタンスの投稿のみに絞れるように
* 検索で特定のユーザーの投稿のみに絞れるように

### 🐛Fixes
* 投稿が増殖する問題を修正
* ストリームで過去の投稿が流れてくる問題を修正
* モバイル版のユーザーページで遷移してもユーザー名が変わらない問題を修正
* お知らせを切り替えても内容が変わらない問題を修正

11.3.1 (2019/04/24)
-------------------
### 🐛Fixes
* Webからファイルがアップロードできない問題を修正

11.3.0 (2019/04/24)
-------------------
### ✨ Improvements
* お知らせにMFMを使えるように
* お知らせに画像を添付できるように

### 🐛Fixes
* 投稿のタグ検索APIで大文字小文字が区別されていたのを修正
* 公開範囲がホームの投稿がグローバルTLに流れる問題を修正
* モバイルビューの投稿詳細にて acct が長いとアイコンが圧迫面接される問題を修正

11.2.2 (2019/04/22)
-------------------
### 🐛Fixes
* 2段階認証を有効にするとログインできない問題を修正
* リモートユーザーの修復処理が自動的に実行されない問題を修正
* リモートユーザー情報が更新されない問題を修正

11.2.1 (2019/04/21)
-------------------
### 🐛Fixes
* MEIDが25桁になっているのを修正
* リモートユーザー情報が更新されない問題を修正

11.2.0 (2019/04/18)
-------------------
### ✨ Improvements
* 検索で日付(日時)を入力するとタイムラインをその時点まで遡るように
* APIコンソールでエンドポイントをサジェストするように
* モバイル版でドライブのメニューを使いやすく
* サイレンス時に確認を表示するように
* ユーザーメニューでブロックなどの操作を行う時に確認するように

### 🐛Fixes
* アプリケーション連携画面でパーミッションが表示されない問題を修正
* アンケートウィジットでもMFMを使用するように
* フォローしてないユーザーのホーム投稿がSTLに流れてくる問題を修正
* モバイル版でウィジェットを設定できない問題を修正
* スプラッシュがクリックに反応するように

11.1.6 (2019/04/18)
-------------------
### 🐛Fixes
* 未認知ユーザーからActivityが飛んできた場合に処理できない問題を修正
* その投稿を見たのにも関わらずメンションインジケーターが点灯し続ける問題を修正
* ハッシュタグの判定を改善
* サーバーのエラーハンドリングを改善

11.1.5 (2019/04/17)
-------------------
### 🐛Fixes
* ユーザー名に含まれているカスタム絵文字が表示されないことがある問題を修正
* 壁紙の設定ができない問題を修正
* デザインの調整

11.1.4 (2019/04/17)
-------------------
### 🐛Fixes
* タイムライン取得時に削除されたファイルを添付している投稿が含まれているとサーバーでエラーになる問題を修正
* 管理画面のインスタンスメニューで変更前の設定が読み込まれないことがある問題を修正
* 猫ではないのに猫のままで表示される問題を修正
* admin/driveのアイコンがずれてる問題を修正
* チャートで大きな数値を扱えない問題を修正
* UIの修正

11.1.3 (2019/04/16)
-------------------
### 🐛Fixes
* アプリからAPIにリクエストするときにランダムなユーザーがリクエストしたことになる問題を修正

11.1.2 (2019/04/15)
-------------------
### 🐛Fixes
* 画像描画の依存関係を変更
* リモートユーザーのファイルを削除するときに古い方からではなく新しい方から削除されるのを修正
* リアクションしてないのにリアクションしたことになる問題を修正
* APIドキュメントの修正

11.1.1 (2019/04/15)
-------------------
### 🐛Fixes
* Metaタグの application-name を Misskey で固定するように修正
* トークメッセージが既読にならない問題を修正
* デフォルトでHTLを表示するように

11.1.0 (2019/04/15)
-------------------
### ✨ Improvements
* アイコン未設定時にランダムな画像を表示するように
* 管理者やモデレーターはレートリミット無効に

### 🐛Fixes
* メンションの「あなた」インジケーターが表示されない問題を修正
* ブロックAPIでエラーが発生する問題を修正
* プッシュ通知の購読に失敗する問題を修正

11.0.3 (2019/04/15)
-------------------
### 🐛Fixes
* ハッシュタグ検索APIが動作しない問題を修正
* モデレーターなのにアカウントメニューに「管理」が表示されない問題を修正
* プッシュ通知の購読に失敗する問題を修正
* ユーザー取得APIでユーザーを指定しない場合エラーになる問題を修正

11.0.2 (2019/04/15)
-------------------
### 🐛Fixes
* アプリが作成できない問題を修正
* 「ハイライト」が表示されない問題を修正
* リモートの投稿に添付されている画像が小さい問題を修正
* モバイル版でリストの名前が表示されない問題を修正
* APIドキュメントにパーミッション一覧を追加

11.0.1 (2019/04/15)
-------------------
### ✨ Improvements
* 不要な依存関係を削除

11.0.0 daybreak (2019/04/14)
----------------------------
### ✨ Improvements
* **データベースがMongoDBからPostgreSQLに変更されました**
* **Redisが必須に**
* アカウントを完全に削除できるように
* 投稿フォームで添付ファイルの閲覧注意を確認/設定できるように
* ミュート/ブロック時にそのユーザーの投稿のウォッチをすべて解除するように

### 🐛Fixes
* フォロー申請数が実際より1すくなくなる問題を修正
* リストからアカウント削除したユーザーを削除できない問題を修正
* リストTLでフォローしていないユーザーの非公開投稿が流れる問題を修正
* リストTLでダイレクト投稿が流れない問題を修正
* ミュートしているユーザーの投稿がタイムラインに流れてくることがある問題を修正

### APIの破壊的変更
* v10時点で deprecated だったパラメータなどを削除
* ユーザーリストの title が name に
* リバーシの対局の`settings`プロパティがなくなり、その中にあったプロパティがすべて上の階層に
  * 例えば`game.settings.map`は`game.map`になる

### 既知の問題
* ユーザー認証無しでのアプリが作成できない
  * 依存ライブラリの問題と思わるため、対応が難しい

### Migration
#### 移行の注意点
**以下のデータは引き継がれません**
* 通知
* リモートの投稿
* リバーシの対局

#### 手順
1. v11をインストールしたい場所に syuilo/misskey をクローン
2. config を設定する
	* PostgreSQL(`db`)の設定とは別に、v10からMongoDBの設定をコピペしてくる(例は下にあります)
	* `id`の設定を`meid`または`objectid`にする

``` yml
db:
  host: localhost
  port: 5432
  db: misskey
  user: x
  pass: x

mongodb:
  user: x
  pass: x
  host: localhost
  port: 27017
  db: misskey
```
3. migration ブランチに切り替え
4. `npm i`
5. `npm run build`
6. `npm run init`
7. `npm run migrate`
8. master ブランチに戻す
9. enjoy

10.100.0
----------
* ユーザーリストでフォローボタンを表示するように
* ドライブのファイルのサムネイルを修正
* 投稿ウィジットでローカルのみの公開範囲で投稿できない問題を修正
* TLを遡った時に抜けがある時がある問題を修正
* ユーザータイムラインが投稿日時順ではなくなっているのを修正
* 10.99.0 でチャートのレンダリングがおかしい問題を修正

10.99.0
----------
* manifest.json にインスタンス名を反映させるように
* Metaに投稿やユーザーのIDを設定するように
* 設定でポートが指定されていない場合、環境変数を参照するように
* フォローインポートで途中にエラーになるユーザーがいると途中で終了してしまう問題を修正
* フォローインポートで自分が含まれていた場合自分をフォローしてしまう問題を修正
* ServiceWorkerの設定がUIで有効にならない問題を修正
* ユーザー一覧でのユーザーの自己紹介が複数行になることがある問題を修正
* フォローインポートでAPI limitに達していても正常にリクエストされたように表示されてしまう問題を修正
* DBに保存されたrepository urlを変更する方法がない問題を修正
* デスクトップDeckだとviaが投稿内に2箇所表示される問題を修正
* デザインの調整
* 依存関係の更新
* ローカリゼーション

10.98.3
----------
* リアクションのカスタム絵文字の情報がNoteに添付されない問題を修正
* フォルダーの移動をするとき親フォルダーに自分自身を指定できてしまう問題を修正
* デザインの調整

10.98.2
----------
* 他のインスタンスから添付画像が見れない問題を修正

10.98.1
----------
* ドライブのファイルのサムネイルが表示されない問題を修正
* APでカスタム絵文字を送る時に常にimage/pngで送っている問題を修正
* いくらいじってもページリロードするとmisskeyのテーマがdark(future)になっちゃう問題を修正

10.98.0
----------
* ドライブのファイルダウンロード時に元のファイル名を尊重するように
* ドライブで画像以外のファイルを分かりやすく表示するように
* TwemojiのCDNを変更
* モバイルで通知の設定がない問題を修正
* デザインの調整

10.97.2
----------
* ビルド時に警告が出ないように修正

10.97.1
----------
* デザインの調整

10.97.0
----------
* リアクションに絵文字やカスタム絵文字を使えるように
* 不明なリアクションのフォールバックに star を使えるように
* デザインの調整

10.96.0
----------
* 連合ユーザーの投稿に対してActivityPubオブジェクトを要求されたら元のインスタンスにリダイレクトするように
* updatePersonを試行した時点でもlastFetchedAtを更新するように
* 管理画面でリモートインスタンスの登録日時を表示
* ユーザーサジェストが機能しなくなっていた問題を修正
* 最近使ったハッシュタグ表示が機能していない問題を修正
* バグ修正
* デザインの調整

10.95.0
----------
* ジョブを一覧できるように
* MFMでURLを明示する構文の追加
* Articleタイプのアクティビティを受け入れるように
* 凍結されたユーザーをサジェストしないように
* ファビコンが保存されないのを修正
* キューのジョブクリアの動作を修正
* デザインの調整

10.94.0
----------
* Faviconを設定できるように
* アカウントを凍結したときすべてのフォローを解除するように
* シェアページが機能していない問題を修正
* インスタンスブロックをしていてもRenote等すると取得されてしまう問題を修正
* デザインの調整

10.93.1
----------
* データのエクスポートとインポートの動作を修正
* デザインの調整

10.93.0
----------
* フォローリストをインポートできるように
* embedプレイヤーを閉じれるように
* リストをインポートしたときにプロキシアカウントがフォローするように修正
* Web Share Targetの動作を修正
* おすすめアンケートのチョイスを修正
* デザインの調整

10.92.4
----------
* リストのエクスポートをできるように
* ジョブキューウィジェットを追加
* URLプレビューのサムネイルが表示されないことがある問題を修正

10.92.3
----------
* 管理画面の各種ジョブ数がおかしい問題を修正
* ジョブキューの動作を調整

10.92.2
----------
* 管理画面で各種ジョブ数を一覧できるように
* ジョブキューの動作を修正
* notes/children が遅い問題を修正

10.92.1
----------
* アンケートの結果をリモートと同期するように
* ジョブキューを有効に
* 投稿の返信一覧に引用Renoteも含めるように
* robots.txt追加
* デザインの調整

10.92.0
----------
* Mastodonのアンケートに対応
* 複数回答できるアンケートを作成できるように
* アンケートに期限を設定できるように
* 絵文字ピッカーを改良
* ハッシュタグの判定を改善
* デッキのタグTLで別のタグをクリックしてもTLが変わらない問題を修正
* ユーザーサジェストで表示名が変わらない問題を修正
* UIのバグ修正
* デザインの調整
* など

10.91.2
----------
* 10.91.1 で追加した依存関係にXSS脆弱性があったので他のパッケージに差し替え
* 初期アクセスでテーマが正しく設定されない問題を修正

10.91.1
----------
* ログビューを強化
* テーマの切り替えをなめらかに
* SVGの判定を修正

10.91.0
----------
* ログを管理画面で見れるように
* 文字サイズを設定できるように
* 返信が表示されない問題を修正
* ユーザーページでユーザーを切り替えても前の人の情報が残る問題を修正
* デザインの調整

10.90.4
----------
* url-previewでembedプレイヤー展開をオプトインにするように
* デザインの調整
* ユーザビリティの強化

10.90.3
----------
* モバイルのデッキで投稿フォームウィジェットが設置できなかった問題を修正
* ドキュメントの強化
* デザインの調整
* ユーザビリティの強化

10.90.2
----------
* アカウントが削除できない問題を修正
* ドキュメントの強化
* デザインの調整

10.90.1
----------
* アカウントを作成したときに自動でホームに遷移しない問題を修正
* ユーザビリティの強化

10.90.0
----------
* モバイル版でもデッキを使えるように
* 公開範囲がホームの投稿はハイライトに載せないように
* ドキュメントの強化
* ユーザーをリストに追加できない問題を修正
* UIの修正

10.89.1
----------
* リアクション数を表示するように
* モバイル版でドライブのフォルダを削除できるように
* ドキュメントの強化
* プロフィールが更新できない場合がある問題を修正
* UIの修正

10.89.0
----------
* APIのエラーの形式を統一
* APIドキュメント刷新
* /api/v1/instance/peers 復活
* 「返信が遷移後も残り続ける問題を修正」([9beddc9](https://github.com/syuilo/misskey/commit/9beddc941a716f1322ae0b7d71d159edd642a399)) によって遷移前に返信が表示されなくなった問題を修正
* デッキモードにてユーザーのプロフィールを連続で見たとき、アクティビティや画像が前のユーザーのもののまま表示される問題を修正

10.88.0
----------
* アカウントの削除を試験的に実装
* デッキでメディア投稿のみ表示するオプションが機能していない問題を修正
* デッキでユーザーを表示したときにタイムラインが残存する問題を修正
* モバイルのユーザーページで、ユーザーAのタイムラインから他のユーザーBを選択してユーザーBのタイムラインに移動したとき、ユーザーAのタイムラインが残る問題を修正
* ハイライトでミュートしているユーザーの投稿が含まれる問題を修正
* 「みつける」でミュートしているユーザーが含まれる問題を修正
* デザインの調整

10.87.5
----------
* モバイル版でも連携サービスを表示するように
* webfingerのacceptが反映されない問題を修正
* 返信が遷移後も残り続ける問題を修正
* デザインの調整

10.87.4
----------
* フォローリクエストを許可するときにエラーになる問題を修正
* デザインの調整

10.87.3
----------
* 開発モードでビルドしてもスクリプトが404になる問題を修正
* 拡張子判別だとアイコンやバナー設定で対応していないと表示される問題を修正
* フォローリクエスト数がおかしい場合の応急処置APIを追加
* デザインの調整

10.87.2
----------
* みつけるの人気のタグを第2ソートで連合含めたユーザー数にしたりユーザーのタグ以外は除外するように
* デザインの調整

10.87.1
----------
* ハッシュタグ検索で大文字小文字が区別されてしまう問題を修正

10.87.0
----------
* ハッシュタグでユーザー検索できるように
* Exploreページに新規ユーザー一覧を追加
* デッキ使用中にホーム扱いで開かれた時にタイムラインボタン等がない問題を修正
* デッキ使用中に / 以外でリロードした際にホームモードになる問題を修正

10.86.2
----------
* 別タブでルートより下を開いたときにはデッキにしないように
* 横のナビゲーションバーの改善
* MIDIファイルがオーディオ扱いになる問題を修正
* ミュートワードで正規表現を使えるように
* デッキで無効になったタイムラインに警告を表示するように
* デザインの調整
* その他細かな修正

10.86.1
----------
* ナビゲーションバーの「ホーム」を「タイムライン」に改称
* モバイル版でユーザーページが二重に描画される問題を修正
* ユーザー一覧の「もっと読み込む」の動作がおかしい問題を修正
* デザインの調整

10.86.0
----------
* Exploreページを実装
* UIを改良
* その他細かな修正

10.85.2
----------
* デッキから フォロー/フォロワー ページに行けるように
* ナビゲーションが発生したときに最上部までスクロールように
* 検索結果でページ遷移が発生する問題を修正
* デザインの調整

10.85.1
----------
* ローカルのみ投稿をログイン画面のタイムラインに表示しないように
* ナビゲーションバーを横にしてるとデッキに行けない問題を修正

10.85.0
----------
* デスクトップ版のUIを改良
* 投稿ハイライトページを実装
* 無効化されているタイムラインのフォールバック
* 既にフォローされている場合はフォローリクエストを生成しないように
* その他細かな修正

10.84.2
----------
* GIF画像にGIFバッジを表示
* よく話すユーザーからサスペンドされたユーザーを隠すなど
* nodeinfoが重い問題を修正
* ハッシュタグクラウド取得が重い問題を軽減

10.84.1
----------
* deckにフォローされていますマークを追加
* URLプレビューのサムネイルの調整
* 管理画面でサイレンスされているユーザーを一覧できるように
* ドキュメントにアクセスできない問題を修正
* ジョブキューを無効化
* 軽微なバグ修正

10.84.0
----------
* インスタンス管理の強化
* パフォーマンスの問題の修正
* バグ修正

10.83.0
----------
* 特定のインスタンスをブロックをできるように
* 特定のインスタンスからのフォローを全解除できるように
* インスタンスごとのチャートを追加

10.82.4
----------
* 10.82.3でオブジェクトストレージの設定をしていると起動しなくなるバグを修正

10.82.3
----------
* フォロー/ミュート/ブロックデータをエクスポート可能に
* バグ修正
* デザインの調整
* ジョブキューの動作を修正

10.82.2
----------
* ジョブキューの動作を修正

10.82.1
----------
* クラスタリング環境でのジョブキューの動作を修正
* その他の軽微な改善

10.82.0
----------
* 自分の投稿情報をエクスポートできるように
* アニメーションする画像を再生しないで表示するオプションを実装
* 個別に投稿のウォッチ/ウォッチ解除をできるように

10.81.0
----------
* 動画のサムネイルを作成するように
* リモートの外部サービス認証情報を表示するように
* public の Renote/Reply/Quote先 が public以外 だったら、public => homeに
* ユーザーページから管理者/モデレーターがアカウントのサイレンス/凍結をできるように
* 凍結されたユーザーをタイムライン等に表示しないように
* おすすめのアンケートでミュートユーザーのものは表示しないように
* おすすめのアンケートで凍結済みユーザーのものは表示しないように
* 画像でないファイルのサムネイルとしてオリジナルファイルを返してしまうのを修正
* URLプレビューのサムネイルが表示されない場合がある問題を修正
* ダークモードで読みにくいボタンがあるのを修正

10.80.0
----------
* サイレンス機能の追加
* リプライ/メンションされていれば非フォロワーへのフォロワー限定でも参照可能に
* MFMの解析を強化
* Misskey以外のインスタンスからMisskeyの投稿を見たときに改行が多い問題を修正
* Misskey以外のインスタンスからMisskeyの投稿を見たときにメンションのURLが展開されるのを修正

10.79.1
----------
* jump構文の追加
* MFMで左回転、往復回転を行えるように
* MFMに関する制限を若干緩和
* シンタックスハイライトに関するバグ修正

10.79.0
----------
* 返信するときにCWを維持するかどうか設定できるように
* 外部サービス認証情報の配信
* 管理画面のモデレーションのUIを強化
* 管理画面からリモートユーザーの情報を更新できるように
* 回転構文の追加
* 左右反転構文の追加
* 複数行の数式構文を追加
* シンタックスハイライトの強化
* 引用投稿を削除したとき単なるRenoteとしてタイムラインに残る問題を修正
* イタリック構文の判定の改善
* タイトル構文の判定の改善
* テーマが反映されないことがある問題を修正
* ホームにフォロワー限定投稿が表示されない問題を修正
* 返信一覧を取得すると非公開投稿も取得されてしまう問題を修正
* メンション一覧を取得すると非公開投稿も取得されてしまう問題を修正
* 通知に非公開投稿が表示される問題を修正
* ダイレクトで投稿すると100％の確率で表示が二重になる問題を修正
* ウィジットの投稿フォームで投稿するとデフォルトの公開範囲が適用されない問題を修正

10.78.5
----------
* アンケートの選択肢にカスタム絵文字を使えるように
* 投稿の返信を取得したときにミュートが適用されていない問題を修正
* ユーザビリティの強化

10.78.4
----------
* フォロワー限定投稿がユーザータイムラインに含まれていない問題を修正
* データベースのインデックス設定を修正
* UIの修正
* など

10.78.3
----------
* 投票未対応インスタンス向けメッセージをわかりやすく
* リバーシが404になる問題を修正
* デザインの修正

10.78.2
----------
* リバーシが404になる問題を修正
* ストリームで流れてくる投稿とAPIでタイムラインを取得したときとの不一致を修正

10.78.1
----------
* 「関係のない返信がタイムラインに流れる問題を修正」を取り消し
* デザインの修正

10.78.0
----------
* 他のインスタンスからアンケートに投票できるように
* スパムアカウントを報告できるように
* アクティブユーザー数のチャートを追加
* 管理画面でドライブのファイルをURLやIDから操作できるように
* リアクション解除を他のサーバーと送受信するように
* ログイン時に二段階認証が分かりにくいのを改善
* 投稿のツールチップを出すのは時間の上だけに変更
* `*`や`_`でもイタリック構文を使えるように(アルファベットのみ)
* `__`でも太字構文を使えるように(アルファベットのみ)
* ハッシュタグ判定の強化
* ストーク機能の廃止
* ソーシャルタイムラインにフォロワー限定投稿が含まれていない問題を修正
* リストタイムラインでフォロワー限定投稿が含まれていない問題を修正
* リストタイムラインに自分宛てでないダイレクト投稿が非公開扱いで表示される問題を修正
* 自分宛てのダイレクト投稿がホーム/ソーシャルタイムラインにストリームで流れない問題を修正
* ストリームで投稿が流れてきたとき、返信先が「この投稿は非公開です」となる問題を修正
* 関係のない返信がタイムラインに流れる問題を修正
* 常にメディアを閲覧注意として投稿するオプションが機能していなかった問題を修正
* リモートユーザーのアイコンが消えることがある問題を修正
* ドライブのファイルメニューからアバターやバナーに設定することができない問題を修正
* クライアントのAPIリクエストをストリーム経由で行うオプションを廃止
* 一部箇所でカスタム絵文字が適用されていないのを修正

10.77.0
----------
* ローカルタイムライン無効オプションをグローバルタイムライン無効オプションと分離
* モデレータはLTL無効時でもUIからLTLを消さない
* インスタンス情報ページに各種タイムラインの有効/無効を表示

10.76.0
----------
* disableLocalTimeline機能を強化
* インスタンス情報ページの強化
* ハッシュタグ判定の強化
* SVGサムネイルを表示するように
* CWの引き継ぎ機能を無効化

10.75.0
----------
* ダイレクトを非公開のように使えるように
* モデレーターを凍結できないように
* モデレーター登録を解除できるように
* NSFWなメディアをユーザーページなどで表示しないように
* 管理画面でユーザーを状態でフィルタできるように
* 管理者がサインイン履歴を参照できるツール
* Renote数を再度表示するように
* インスタンス情報ページの追加
* テーマの調整
* UIの改善

10.74.0
----------
* Pleromaとのフェデレーションを修正
* インスタンスのキャラクター画像を設定できるように
* Catモードの朝鮮語対応
* CWが付いた投稿に返信する際、そのCWを引き継ぐように
* 投稿のソースをクリップボードにコピーできるように
* i/notifications API で取得する通知の種別を配列で指定できるように
* パフォーマンスの改善
* バグ修正

10.73.0
-------
* テーマの強化
* line thiknessの設定はデバイスに保存するように

10.72.0
-------
* いくつかのテーマの追加
* デザインの調整
* バグ修正
* など

10.71.0
-------
* いくつかのテーマの追加

10.70.1
-------
* notes/mentions にミュートを適用するように
* Add id to return of users/relation
* デザインの調整

10.70.0
-------
* フォローしているユーザーからのフォローを自動承認するオプション
* 「非公開」の公開範囲を廃止
* Renote数の表示を廃止
* 投稿のフィルタリングを強化
* デザインの調整

10.69.0
-------
* 通知の管理を強化
* ユーザビリティの強化
* デザインの調整

10.68.0
-------
* 特定ユーザーにメンション付きで新規投稿ができるボタンを追加
* 自分の投稿にリアクションできないように
* 数式に文法エラーがあるとき、数式のソースをそのまま表示するように
* CWボタンにアンケートの有無を表記するように
* デスクトップ版で設定を新しいタブで開くように
* モバイル版で検索ができない問題を修正
* i18nの修正

10.67.0
-------
* トークのメッセージを削除できるように
* リアクションを取り消せるように
* Misskey以外のソフトウェアからの「Like」アクティビティをプリンではなく「いいね」として扱うように
* i18nの修正
* バグ修正
* など

10.66.2
-------
* i18nの修正
* ドライブのファイル一覧取得APIでファイルサイズによるソートが機能していなかった問題を修正
* リモートユーザーの更新時に、各ピン留め投稿の取得失敗は無視するように
* リモートMisskeyユーザーの情報が登録/更新出来なくなっていたのを修正
* メンションのリンク先URLに余計な@がプリフィクスされていたのを修正
* ダイレクトでリプライする際、リプライ先のユーザーは自動的に公開先として追加するように
* ダイレクトでメンションでもユーザーを指定できるように

10.66.1
-------
* ActivityPubのsharedInboxに関して修正
* MFMでのカッコの判定を改善
* バグ修正

10.66.0
-------
* ユーザーごとのRSSフィードを提供するように
* リストのユーザーがすべて表示できない問題を修正
* デザインの調整
* パフォーマンスの改善

10.65.0
-------
* 検索で投稿やユーザーのURLを入力した際にそれをフェッチして表示するように
* リストのリネームと削除をできるように
* リストからユーザーを削除できるように
* リモートの絵文字を更新するように
* ActivityPubのための絵文字エンドポイントを実装
* 管理者がドライブのファイルのNSFWを設定できるように
* ServiceWorkerの設定を管理者ページで行えるように
* メンションの判定を改善
* リモートの投稿を引用した際にオリジナルのURLを挿入するように
* クライアントのパフォーマンス改善
* CWの内容がタブタイトルに表示されるのを修正
* アカウントを作成したときにログイン状態にならない問題を修正
* 時計の針にテーマカラーが適用されていなかったのを修正
* 一部の日時の表示が日本語で表示されていたのを修正
* プロフィールの写真欄に画像以外のファイルが含まれる問題を修正
* メンションが含まれる投稿に返信する際、フォームに予めそれらのメンションがセットされた状態にならない問題を修正
* デッキのTLにUIの動きを減らすオプションが適用されていなかったのを修正
* ログイン画面のタイムラインに隠した投稿が表示される問題を修正
* サジェストが複数開いてしまう問題を修正
* APから来たタグに登録時の長さ制限が適用されていなかったのを修正

10.64.2
-------
* UIの動きを減らすオプションが一部のアニメーションに適用されなかったのを修正

10.64.1
-------
* レートリミットの調整
* アニメーションの調整

10.64.0
-------
* いくつかのアニメーションを追加
* OGP向けにインスタンスのバナー画像を提供するように
* 管理者ページでドライブのファイルを表示できるように
* ユーザビリティの強化
* バグ修正

10.63.1
-------
* メンションの表示を改善
* バグ修正

10.63.0
-------
* ActivityPubのユーザーフィールドをユーザーページに表示
* 404ページの実装
* パフォーマンスの向上
* バグ修正

10.62.2
-------
* バグ修正
* ユーザビリティの向上

10.0.0
------

ストリーミングAPIに破壊的変更があります。運営者がすべきことはありません。

変更は以下の通りです

* ストリーミングでやり取りする際の snake_case が全て camelCase に
* リバーシのストリームエンドポイント名が reversi → gamesReversi、reversiGame → gamesReversiGame に
* ストリーミングの個々のエンドポイントが廃止され、一旦元となるストリームに接続してから、個々のチャンネル(今までのエンドポイント)に接続します。詳細は後述します。
* ストリームから流れてくる、キャプチャした投稿の更新イベントに投稿自体のデータは含まれず、代わりにアクションが設定されるようになります。詳細は後述します。
* ストリームに接続する際に追加で指定していたパラメータ(トークン除く)が、URLにクエリとして含むのではなくチャンネル接続時にパラメータ指定するように

### 個々のエンドポイントが廃止されることによる新しいストリーミングAPIの利用方法
具体的には、まず https://example.misskey/streaming にwebsocket接続します。
次に、例えば「messaging」ストリーム(チャンネルと呼びます)に接続したいときは、ストリームに次のようなデータを送信します:
``` javascript
{
  type: 'connect',
  body: {
    channel: 'messaging',
    id: 'foobar',
    params: {
      otherparty: 'xxxxxxxxxxxx'
    }
  }
}
```
ここで、`id`にはそのチャンネルとやり取りするための任意のIDを設定します。
IDはチャンネルごとではなく「チャンネルの接続ごと」です。なぜなら、同じチャンネルに異なるパラメータで複数接続するケースもあるからです。
`params`はチャンネルに接続する際のパラメータです。チャンネルによって接続時に必要とされるパラメータは異なります。パラメータ不要のチャンネルに接続する際は、このプロパティは省略可能です。

チャンネルにメッセージを送信するには、次のようなデータを送信します:
``` javascript
{
  type: 'channel',
  body: {
    id: 'foobar',
    type: 'something',
    body: {
      some: 'thing'
    }
  }
}
```
ここで、`id`にはチャンネルに接続するときに指定したIDを設定します。

逆に、チャンネルからメッセージが流れてくると、次のようなデータが受信されます:
``` javascript
{
  type: 'channel',
  body: {
    id: 'foobar',
    type: 'something',
    body: {
      some: 'thing'
    }
  }
}
```
ここで、`id`にはチャンネルに接続するときに指定したIDが設定されています。

### 投稿のキャプチャに関する変更
投稿の更新イベントに投稿情報は含まれなくなりました。代わりに、その投稿が「リアクションされた」「アンケートに投票された」「削除された」といったアクション情報が設定されます。

具体的には次のようなデータが受信されます:
``` javascript
{
  type: 'noteUpdated',
  body: {
    id: 'xxxxxxxxxxx',
    type: 'reacted',
    body: {
      reaction: 'hmm'
    }
  }
}
```

* reacted ... 投稿にリアクションされた。`reaction`プロパティにリアクションコードが含まれます。
* pollVoted ... アンケートに投票された。`choice`プロパティに選択肢ID、`userId`に投票者IDが含まれます。

9.0.0
-----

Misskey v8.64.0 を使っている方は、9.0.0に際しては特にすべきことはありません。
Misskey v8.64.0 に満たないバージョンをお使いの方は、一旦8.64.0にアップデートして(そして起動して)から9.0.0に再度アップデートしてください。

8.0.0
-----

### Migration

起動する前に、`node cli/migration/8.0.0`してください。

Please run `node cli/migration/8.0.0` before launch.


7.0.0
-----

### Migration

起動する前に、`node cli/migration/7.0.0`してください。

Please run `node cli/migration/7.0.0` before launch.

6.0.0
-----

### Migration

オブジェクトストレージを使用している場合、設定ファイルの`drive.config.secure`を`drive.config.useSSL`にリネームしてください。

If you use object storage, please rename `drive.config.secure` to `drive.config.useSSL` in config.

5.0.0
-----

### Migration

起動する前に、`node cli/migration/5.0.0`してください。

Please run `node cli/migration/5.0.0` before launch.

4.0.0
-----

オセロがリバーシに変更されました。

Othello is rename to Reversi.

### Migration

MongoDBの、`othelloGames`と`othelloMatchings`コレクションをそれぞれ`reversiGames`と`reversiMatchings`にリネームしてください。

Please rename `othelloGames` and `othelloMatchings` MongoDB collections to `reversiGames` and `reversiMatchings` respectively.

3.0.0
-----

### Migration

起動する前に、`node cli/recount-stats`してください。

Please run `node cli/recount-stats` before launch.
